> For the complete documentation index, see [llms.txt](https://docs.wisej.com/api/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.wisej.com/api/wisej.services/general/wisej.services.servicelifetime.md).

# ServiceLifetime

Namespace: **Wisej.Services**

Assembly: **Wisej.Framework** (4.0.0.0)

Specifies the lifetime of a service.

{% tabs %}
{% tab title="C#" %}

```csharp
public enum ServiceLifetime : Enum
```

{% endtab %}

{% tab title="VB.NET" %}

```visual-basic
Public Enum ServiceLifetime As [Enum]
```

{% endtab %}
{% endtabs %}

## Fields

| Name          | Description                                                                                                                                                                                                                             |
| ------------- | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **Session**   | A new instance of the service is created and cached for the current session; it will be automatically disposed, if it implements an [IDisposable](https://docs.microsoft.com/dotnet/api/system.idisposable), at the end of the session. |
| **Shared**    | A single static instance of the service is available to all sessions.                                                                                                                                                                   |
| **Thread**    | A new instance of the service is created for each new thread; it will be automatically disposed, if it implements an [IDisposable](https://docs.microsoft.com/dotnet/api/system.idisposable), at the end of the request.                |
| **Transient** | A new instance of the service is created every time it's requested. The consumer is responsible for disposing it.                                                                                                                       |

## Used By

| Name                                                                                                                              | Description                                                                                                           |
| --------------------------------------------------------------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| [ServiceProvider.AddService](/api/wisej.services/general/wisej.services.serviceprovider.md#addservice-lifetime)                   | Registers a scoped service.                                                                                           |
| [ServiceProvider.AddOrReplaceService](/api/wisej.services/general/wisej.services.serviceprovider.md#addorreplaceservice-lifetime) | <p>Registers or replaces a scoped service.<br><mark style="color:blue;background-color:green;">Since 4.0.0</mark></p> |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.wisej.com/api/wisej.services/general/wisej.services.servicelifetime.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
